/***************************************
  $Revision: 1.3 $

  Error reporting (er) erroutines.h  - definition of error reporting aspects.

  Status: NOT REVUED, TESTED, 

  Design and implementation by: Marek Bukowy

  ******************/ /******************
  Copyright (c) 1999                              RIPE NCC
 
  All Rights Reserved
  
  Permission to use, copy, modify, and distribute this software and its
  documentation for any purpose and without fee is hereby granted,
  provided that the above copyright notice appear in all copies and that
  both that copyright notice and this permission notice appear in
  supporting documentation, and that the name of the author not be
  used in advertising or publicity pertaining to distribution of the
  software without specific, written prior permission.
  
  THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
  ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; IN NO EVENT SHALL
  AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
  DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
  AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  ***************************************/

/* define a list of aspects for debugging. Just a simple enumeration */

typedef enum {
  /* Global */
  
  ASP_CIRC_BUF = 0x40000000,   /* write also into the circular buffer */
    /* 0x20000000 - 0x01000000  are reserved for global tags */
  
  /* RADIX: */
  ASP_RX_NODCRE_GEN = 0x800000,     /* general node creation tag */
  ASP_RX_NODCRE_DET = 0x400000,     /* also details on node creation */
  ASP_RX_NODCRE_BOT = 0xC00000,     /* both general and detailed */

  ASP_RX_STKBLD_GEN = 0x200000,     /* general stack building */
  ASP_RX_STKBLD_DET = 0x100000,     /* also detailed stack building */
  ASP_RX_STKBLD_BOT = 0x300000,     /* both general and detailed */
  
  ASP_RX_SRCH_GEN   = 0x080000,     /* search */
  ASP_RX_SRCH_DET   = 0x040000,
  ASP_RX_SRCH_BOT   = 0x0C0000,

  ASP_RX_TREE_GEN = 0x020000,     /* general tree/forest administration */
  ASP_RX_TREE_DET = 0x010000,     /* detailed */
  ASP_RX_TREE_BOT = 0x030000,     /* both general and detailed */


  ASP_RX_TREE_WALK = 0x000001

} er_asp_t;
